﻿Public Class frmPrehMat
    Private Sub TblMaterialBindingNavigatorSaveItem_Click(sender As Object, e As EventArgs)
        Me.Validate()
        Me.TblMaterialBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.DsData)

    End Sub

    Private Sub frmPrehMat_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'DsData.tblMerneJednotky' table. You can move, or remove it, as needed.
        Me.TblMerneJednotkyTableAdapter.Fill(Me.DsData.tblMerneJednotky)
        'TODO: This line of code loads data into the 'DsData.tblPalety' table. You can move, or remove it, as needed.
        Me.TblPaletyTableAdapter.Fill(Me.DsData.tblPalety)
        'TODO: This line of code loads data into the 'DsData.tblMaterial' table. You can move, or remove it, as needed.
        Me.TblMaterialTableAdapter.Fill(Me.DsData.tblMaterial)

        rbRaditCisloMat.Checked = True

        tstbHledani.ImageIndex = 0

    End Sub

    Private Sub btnZavrit_Click(sender As Object, e As EventArgs) Handles btnZavrit.Click
        Close()
    End Sub

    Private Sub btnPrvni_Click(sender As Object, e As EventArgs) Handles btnPrvni.Click
        TblMaterialBindingSource.MoveFirst()
    End Sub

    Private Sub btnPosledni_Click(sender As Object, e As EventArgs) Handles btnPosledni.Click
        TblMaterialBindingSource.MoveLast()
    End Sub

    Private Sub RefreshRazeni()
        If rbRaditCisloMat.Checked Then
            TblMaterialBindingSource.Sort = "ID_Materialu ASC"
        Else
            TblMaterialBindingSource.Sort = "Nazev_Mat ASC"
        End If

    End Sub


    Private Sub rbRaditCisloMat_CheckedChanged(sender As Object, e As EventArgs) Handles rbRaditCisloMat.CheckedChanged
        RefreshRazeni()
    End Sub

    Private Sub rbRaditNazevMat_CheckedChanged(sender As Object, e As EventArgs) Handles rbRaditNazevMat.CheckedChanged
        RefreshRazeni()
    End Sub

    Private Sub TblMaterialDataGridView_Sorted(sender As Object, e As EventArgs) Handles dgvMaterial.Sorted
        rbRaditCisloMat.Checked = (dgvMaterial.SortedColumn.Index = 0)
        rbRaditNazevMat.Checked = (dgvMaterial.SortedColumn.Index = 1)
    End Sub

    Private Sub btnHledej_Click(sender As Object, e As EventArgs) Handles btnHledej.Click
        cmsHledej.Show(Cursor.Position)

        Dim col As New AutoCompleteStringCollection
        Dim colname As String = IIf(rbRaditCisloMat.Checked, "ID_Materialu", "Nazev_Mat")

        For Each row As DataRow In DsData.tblMaterial.Rows
            If row.RowState <> DataRowState.Deleted Then col.Add(row(colname))
        Next

        tstbHledani.AutoCompleteCustomSource = col
        tstbHledani.AutoCompleteMode = AutoCompleteMode.SuggestAppend
        tstbHledani.AutoCompleteSource = AutoCompleteSource.CustomSource
        tstbHledani.Focus()


    End Sub

    Private Sub tstbHledani_KeyDown(sender As Object, e As KeyEventArgs) Handles tstbHledani.KeyDown
        If e.KeyCode = Keys.Enter Then


            Dim pozice As Integer
            Dim colname As String = IIf(rbRaditCisloMat.Checked, "ID_Materialu", "Nazev_Mat")

            '' try: kvuli problemu s formaty, napr. hledani textu ve sloupci s cisly
            Try
                pozice = TblMaterialBindingSource.Find(colname, tstbHledani.Text)
                If pozice > -1 Then TblMaterialBindingSource.Position = pozice
            Catch ex As Exception

            End Try

            cmsHledej.Text = ""
            cmsHledej.Hide()
        End If
    End Sub

    Private Sub btnOdstranit_Click(sender As Object, e As EventArgs) Handles btnOdstranit.Click

        If SpustSQL("SELECT * FROM tblPalety WHERE ID_Materialu=" & TblMaterialBindingSource.Current("ID_Materialu")).Count > 0 Then
            MsgBox("Nelze smazat, existují související záznamy", MsgBoxStyle.Exclamation, "POZOR")
        Else
            TblMaterialBindingSource.RemoveCurrent()
            UlozDoDb("Nepodařilo se záznam smazat")
        End If

    End Sub

    Private Sub TblMaterialBindingSource_PositionChanged(sender As Object, e As EventArgs) Handles TblMaterialBindingSource.PositionChanged

        Dim selCrit As String = "ID_Materialu = " & TblMaterialBindingSource.Current("ID_Materialu")

        If DsData.tblPalety.Select(selCrit).Count > 0 Then
            tbCelkoveMnozstvi.Text = DsData.tblPalety.Compute("SUM (Mnoz_Pa)", "ID_Materialu = " & TblMaterialBindingSource.Current("ID_Materialu"))
        Else
            tbCelkoveMnozstvi.Text = 0
        End If

        'Dim strsql As String = "Select ID_Materialu, SUM(Mnoz_Pa) As Celkem 
        '                        From tblPalety Group By ID_Materialu 
        '                        HAVING(ID_Materialu = " & TblMaterialBindingSource.Current("ID_Materialu") & ")"
        'Dim dv As DataView = SpustSQL(strsql)

        'If dv.Count > 0 Then
        '    tbCelkoveMnozstvi.Text = dv(0)("Celkem")
        'Else
        '    tbCelkoveMnozstvi.Text = 0
        'End If


    End Sub

    Private Sub RezimEditace(editace As Boolean)


        pnlItems.Enabled = editace
        tbKomentar.Enabled = editace
        pnlUkladani.Enabled = editace

        pnlOvladani.Enabled = Not editace
        pnlNavig.Enabled = Not editace
        gbRazeni.Enabled = Not editace
        btnZavrit.Enabled = Not editace
        dgvMaterial.Enabled = Not editace
        dgvPalety.Enabled = Not editace

    End Sub
    Private Sub UlozDoDb(err_hlaska As String)
        Try
            TblMaterialBindingSource.EndEdit()
            TblMaterialTableAdapter.Update(DsData.tblMaterial)
        Catch ex As Exception
            MsgBox(err_hlaska & vbNewLine & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub btnZmenit_Click(sender As Object, e As EventArgs) Handles btnZmenit.Click

        RezimEditace(True)

        cmbMerna.Focus()


    End Sub

    Private Sub btnUlozit_Click(sender As Object, e As EventArgs) Handles btnUlozit.Click
        If Not Me.ValidateChildren() Then Exit Sub

        '  Me.Validate()

        Try
            TblMaterialBindingSource.EndEdit()
            TblMaterialTableAdapter.Update(DsData.tblMaterial)
        Catch ex As Exception
            MsgBox("Chyba při ukládání:" & ex.ToString, MsgBoxStyle.Critical & MsgBoxStyle.OkOnly, "Chyba")
        End Try

        RezimEditace(False)
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        TblMaterialBindingSource.CancelEdit()
        RezimEditace(False)
    End Sub

    Private Sub tbNazevMat_Validated(sender As Object, e As EventArgs) Handles tbNazevMat.Validated
        dgvMaterial.Refresh()
    End Sub

    Private Sub tbNazevMat_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles tbNazevMat.Validating
        JeCokolivControl(sender, e, ErrorProvider1)
    End Sub

    Private Sub tbMaxDoPal_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles tbMaxDoPal.Validating
        JeCeleKladneCisloControl(sender, e, ErrorProvider1)
    End Sub

    Private Sub tbMnozPoj_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles tbMnozPoj.Validating
        JeCeleKladneCisloControl(sender, e, ErrorProvider1)
    End Sub

    Private Sub btnVlozit_Click(sender As Object, e As EventArgs) Handles btnVlozit.Click

        DsData.tblMaterial.ID_MaterialuColumn.DefaultValue = NajdiMaximalniHodnotuVTabulce(DsData.tblMaterial, "ID_Materialu") + 1

        TblMaterialBindingSource.AddNew()
        RezimEditace(True)
    End Sub

    Private Sub cmbMerna_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles cmbMerna.Validating
        JeCokolivControl(sender, e, ErrorProvider1)
    End Sub
End Class